Author: Rens Admiraal Category:
Created: 2010-02-04 Assigned To:
Updated: 2013-07-17 Due date:
Has patch:
Affected Flow version:
Subject: JSON is being parsed as string Array
Description

We have a fluid template with some inline javascript. The JSON objects in it are being parsed as the literal string 'Array'.

It looks like fluid is parsing all array notations in the content instead of just parsing the arrays used in the viewhelper parameters.
There is a workaround for this bug, just add a property to the json containing a viewhelper.

Not working:
 flashes.push({
     id: 'sponsorMeter',
     flashvars: {
         amount:5000,
         maxAmount:700,
         link: "<f:uri.action pageUid='{pages.sponsor}' absolute='true' />",
         type:'zip'
     },
     parameters: {
         wmode:'transparent'
     },
     width: 150,
     height: 260,
     src:'/<f:uri.resource path="Flash/sponsormeter.swf" />'
 });

Working (parameters objects has changed):
 flashes.push({
     id: 'sponsorMeter',
     flashvars: {
         amount:5000,
         maxAmount:700,
         link: "<f:uri.action pageUid='{pages.sponsor}' absolute='true' />",
         type:'zip'
     },
     parameters: {
         link: "<f:uri.action pageUid='{pages.sponsor}' absolute='true' />",
         wmode:'transparent'
     },
     width: 150,
     height: 260,
     src:'/<f:uri.resource path="Flash/sponsormeter.swf" />'
 });

Related issues:
related to TYPO3.Fluid - Feature # 39682: Disregegard { as Fluid variable whe... Rejected 2012-08-10
duplicated by TYPO3.Fluid - Bug # 8879: { } when using as JavaScript Closed 2010-07-15

History
#1 - 2010-03-15 16:34 - Sebastian Kurfuerst
- Status changed from New to Accepted
- Assigned To set to Sebastian Kurfuerst

#2 - 2010-03-15 16:35 - Sebastian Kurfuerst
- Target version set to 1.0.0 alpha 8
- Estimated time set to 10.00
- Branch set to v4 + v5

#3 - 2010-06-18 10:01 - Sebastian Kurfuerst
- Status changed from Accepted to New
- Assigned To deleted (Sebastian Kurfuerst)
- Priority changed from Must have to Could have
- Target version deleted (1.0.0 alpha 8)

we just discussed this again; and as there are workarounds (CDATA), we agreed upon not implementing this right now.
We first need proper testing for the syntax, and it would make the parser context sensitive.

#4 - 2010-07-12 12:42 - Bastian Waidelich
- Status changed from New to Closed

As there are workarounds (wrapping your scripts in CDATA tags) I close this issue for now.
If you don't agree or want to discuss this further, please re-open!
